<template>
  <div class="sidebar" v-if="level">
    <h1>Sidebar</h1>
    
    
    <div v-if="toEdit">
      <div v-for="field in toEdit" :key="field.name">
        {{field}}
        <input type="text" :key="field.name" :value="field.value" @input="updateName">
      </div>
    </div>
  </div>
</template>

<script>
import {useStore} from "vuex"
import {computed} from "vue"


const _ = require("lodash")

export default {
  name: 'Sidebar',
  props: {
    toEdit:Array
  },
  setup(){
    const store = useStore();

    const level = computed(() => store.state.level);
    const statename = computed(()=> store.state.level.chapter.chapter[0].name);

    const updateName = function(e){
      
      console.log("new:::", e.target.value);
      
      console.log("statename:::",statename);
      /*
      let newstate = statename.value;
      newstate = e.target.value;
      console.log(newstate);
      
      //store.commit("setName",newstate); // needed to update store
      */


      const newlevel = _.cloneDeep(level.value);
      console.log("from the clone",newlevel.chapter.chapter[0].name);
      newlevel.chapter.chapter[0].name = e.target.value;
      console.log("from the clone after mutation",newlevel.chapter.chapter[0].name);
      //console.log(newlevel);
      
      store.commit("setLevel",newlevel); 
     
      //TODO: Understand why level (object can be directly written without commit while newstate needs to be commited)
    }

   
    

    return {
      level,
      statename,
      updateName
    }
  },
  methods: {
  increment() {
    this.$store.commit('setCount',this.$store.state.count+1)
    console.log(this.$store.state.count)
  }
  },
  components: {
    
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
h3 {
  margin: 40px 0 0;
}
ul {
  list-style-type: none;
  padding: 0;
}
li {
  display: inline-block;
  margin: 0 10px;
}
a {
  color: #42b983;
}

.sidebar{
  position: fixed;
  right:20px;
  width: 20vw;
  height: 100%;
  background-color: rgba(223, 239, 227, 0.9);
  overflow-x: scroll;
}
</style>
